using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using System.Reflection;
using System.Collections;
using System.Threading.Tasks;
using TMPro;
using UnityEngine.UI;
using Ad01;
using System.Linq;
using System.Globalization;
using Utility01;

namespace GripFix
{
    public class Mod
    {
        public static List<List<PhysicalBehaviour>> contraptionsArray = new List<List<PhysicalBehaviour>>();
        public static void OnLoad()
        {
            Ad.ShowAd(new Ad.Settings("GripFix", "https://youtu.be/I05-4-fhELg", true, Utility.GetTranslatedString("I have prepared a video to demonstrate the mod's work. Do you want to take a look to avoid further questions? (I highly recommend it)", "Я подготовил видео, чтобы продемонстрировать работу мода. Советую посмотреть, да, теперь я перевожу моды на русский :D"), Utility.GetTranslatedString("Here you can join our discord community and go to other sources. And also support the developer.", "Здесь вы можете присоединится к нашему серверу Discord и другим ресурсам. А также поддержать разработчика.")));
        }
        public static void Main()
        {

            ModAPI.OnWireCreated += ModAPI_OnWireCreated;
            ModAPI.OnWireDestroyed += ModAPI_OnWireDestroyed;
            ModAPI.OnItemRemoved += ModAPI_OnItemRemoved;
            ModAPI.Register<GripFinder>();
        }

        private static void ModAPI_OnItemRemoved(object sender, UserSpawnEventArgs e)
        {
            bool physAlreadyInContraption = false;
            foreach (var contraption in contraptionsArray)
            {
                foreach (var phys in contraption)
                {
                    if (phys == e.Instance.GetComponent<PhysicalBehaviour>())
                    {
                        physAlreadyInContraption = true;
                    }
                }
                if (physAlreadyInContraption)
                {
                    contraption.Remove(e.Instance.GetComponent<PhysicalBehaviour>());
                }
                if (contraption.Count == 0)
                {
                    contraptionsArray.Remove(contraption);
                }
            }
        }

        private static void ModAPI_OnWireDestroyed(object sender, WireBehaviour e)
        {
            bool physAlreadyInContraption = false;
            bool otherPhysAlreadyInContraption = false;
            foreach (var contraption in contraptionsArray)
            {
                foreach (var phys in contraption)
                {
                    if (phys == e.physicalBehaviour)
                    {
                        physAlreadyInContraption = true;
                    }
                    if (phys == e.otherPhysicalBehaviour)
                    {
                        otherPhysAlreadyInContraption = true;
                    }
                }
                if (physAlreadyInContraption)
                {
                    contraption.Remove(e.otherPhysicalBehaviour);
                }
                else if (otherPhysAlreadyInContraption)
                {
                    contraption.Remove(e.physicalBehaviour);
                }
                if (contraption.Count == 0)
                {
                    contraptionsArray.Remove(contraption);
                }
            }
        }

        private static void ModAPI_OnWireCreated(object sender, WireBehaviour e)
        {
            bool physAlreadyInContraption = false;
            bool otherPhysAlreadyInContraption = false;
            List<List<PhysicalBehaviour>> findedContraptions = new List<List<PhysicalBehaviour>>();
            foreach (var contraption in contraptionsArray)
            {
                foreach (var phys in contraption)
                {
                    if (phys == e.physicalBehaviour)
                    {
                        findedContraptions.Add(contraption);
                        physAlreadyInContraption = true;
                    }
                    if (phys == e.otherPhysicalBehaviour)
                    {
                        findedContraptions.Add(contraption);
                        otherPhysAlreadyInContraption = true;
                    }
                }
                if (physAlreadyInContraption && !otherPhysAlreadyInContraption)
                {
                    contraption.Add(e.otherPhysicalBehaviour);
                }
                else if (!physAlreadyInContraption && otherPhysAlreadyInContraption)
                {
                    contraption.Add(e.physicalBehaviour);
                }
            }
            if (!physAlreadyInContraption && !otherPhysAlreadyInContraption)
            {
                var newContraptionArray = new List<PhysicalBehaviour>();
                newContraptionArray.Add(e.physicalBehaviour);
                newContraptionArray.Add(e.otherPhysicalBehaviour);
                contraptionsArray.Add(newContraptionArray);
            }
            var findedContraptionsWithoutDupes = findedContraptions.Distinct().ToList();
            if (findedContraptionsWithoutDupes.Count > 1)
            {
                CombineContraptions(findedContraptionsWithoutDupes);
            }

        }
        private static List<PhysicalBehaviour> CombineContraptions(List<List<PhysicalBehaviour>> contraptions)
        {
            List<PhysicalBehaviour> result = new List<PhysicalBehaviour>();
            foreach (var contraption in contraptions)
            {
                foreach (var phys in contraption)
                {
                    result.Add(phys);
                }
                contraptionsArray.Remove(contraption);
            }
            var resultWithoutDupes = result.Distinct().ToList();
            contraptionsArray.Add(resultWithoutDupes);
            return resultWithoutDupes;
        }
        private static void ModAPI_OnItemSpawned(object sender, UserSpawnEventArgs e)
        {

        }

    }
    [RequireComponent(typeof(GripBehaviour))]
    public class GripBehaviourBetter : MonoBehaviour
    {
        public bool gripped;
        public GripBehaviour gripBehaviour;
        public PersonBehaviour personBehaviour;
        private List<PhysicalBehaviour> lastContraption;
        public void Update()
        {
            if (!gripped && gripBehaviour.CurrentlyHolding != null)
            {
                gripped = true;
                Grip(gripBehaviour.CurrentlyHolding);
            }
            else if (gripped && gripBehaviour.CurrentlyHolding == null)
            {
                gripped = false;
                foreach (var phys in lastContraption)
                {
                    foreach (var limb in personBehaviour.Limbs)
                    {
                        Physics2D.IgnoreCollision(phys.gameObject.GetComponent<Collider2D>(), limb.gameObject.GetComponent<Collider2D>(), false);
                    }
                }
                lastContraption = null;
            }
        }
        private void Grip(PhysicalBehaviour physicalBehaviour)
        {
            Vector3 oldPosition = physicalBehaviour.gameObject.GetComponent<GripObject>().oldPosition;
            Vector3 newPosition = physicalBehaviour.gameObject.transform.position;
            foreach (var contraption in Mod.contraptionsArray)
            {
                foreach (var phys in contraption)
                {
                    if (phys == physicalBehaviour)
                    {
                        lastContraption = contraption;
                    }
                }
            }
            if (lastContraption != null)
            {
                foreach (var phys in lastContraption)
                {
                    if (phys != physicalBehaviour)
                    {
                        var offsetX = -(oldPosition.x - newPosition.x);
                        var offsetY = -(oldPosition.y - newPosition.y);
                        var position = phys.gameObject.transform.position;
                        phys.gameObject.transform.position = new Vector3(position.x + offsetX, position.y + offsetY);
                        foreach (var limb in personBehaviour.Limbs)
                        {
                            Physics2D.IgnoreCollision(phys.gameObject.GetComponent<Collider2D>(), limb.gameObject.GetComponent<Collider2D>(), true);
                        }
                    }
                }
            }
        }
    }
    public class GripFinder : MonoBehaviour
    {
        private void Start()
        {
            StartCoroutine(CustomUpdate());
        }
        public IEnumerator CustomUpdate()
        {
            yield return new WaitForSecondsRealtime(0.1f);

            foreach (var gripBehaviour in GameObject.FindObjectsOfType<GripBehaviour>())
            {
                if (!gripBehaviour.gameObject.GetComponent<GripBehaviourBetter>())
                {
                    var listener = gripBehaviour.gameObject.AddComponent<GripBehaviourBetter>();
                    listener.gripBehaviour = gripBehaviour;
                    listener.personBehaviour = listener.gripBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>();
                }
            }
            foreach (var gripObj in GameObject.FindObjectsOfType<PhysicalBehaviour>())
            {
                if (gripObj.HoldingPositions.Length > 0 && !gripObj.gameObject.GetComponent<GripObject>())
                {
                    gripObj.gameObject.AddComponent<GripObject>();
                }
            }
            StartCoroutine(CustomUpdate());
        }
    }
    public class GripObject : MonoBehaviour
    {
        public Vector3 oldPosition;
        private void Start()
        {
            StartCoroutine(CustomUpdate());
        }
        public IEnumerator CustomUpdate()
        {
            yield return new WaitForSecondsRealtime(0.05f);
            oldPosition = gameObject.transform.position;
            StartCoroutine(CustomUpdate());
        }
    }
}
